/*----- PROTECTED REGION ID(Agilent33500B.h) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent33500B.h
//
// description : Include file for the Agilent33500B class
//
// project :     Agilent33500B
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Agilent33500B_H
#define Agilent33500B_H

#include <tango.h>
#include "SCPI.h"


/*----- PROTECTED REGION END -----*/	//	Agilent33500B.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  Agilent33500B class description:
 *    A class to control the Agilent 33500B waveform generator
 */


namespace Agilent33500B_ns
{
/*----- PROTECTED REGION ID(Agilent33500B::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Agilent33500B::Additional Class Declarations

class Agilent33500B : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Agilent33500B::Data Members) ENABLED START -----*/

//	Add your own data members

public:
		Scpi *scpi;
		int waveFormLgth;
		omni_mutex mutex;
		int sequence_running;
		string sequence_error;
    char full_file_name[512];
    void load_configuration();
    double amplitudeSetpoint;
    double offsetSetpoint;

private:
		time_t lastUpdate;
		char config_file[512];

		void reload_waveform();

		void save_waveform(double *wave, int nb);

		void update_attr(string att_name, double value);

    void update_attr(string att_name,short value);

    string get_write_value_from_db(string attName);

		double get_write_value_double(string att_name);

		short get_write_value_short(string att_name);

		void set_wvalue(string name, double value);

		void set_wvalue(string name, short value);

/*----- PROTECTED REGION END -----*/	//	Agilent33500B::Data Members

//	Device property data members
public:
	//	IPAddress:	
	std::string	iPAddress;
	//	Output:	Output number (Start from 1)
	Tango::DevShort	output;
	//	Timeout:	Communication timeout (millisec)
	Tango::DevLong	timeout;
	//	WaveformFile:	Name of the file where the waveform is stored
	std::string	waveformFile;
	//	ConfigFilePath:	Absolute path were config file are stored
	std::string	configFilePath;
	//	ConfigFile:	Configuration file
	std::string	configFile;
	//	TrackModeSupport:	true if Track mode is supported
	Tango::DevBoolean	trackModeSupport;
	//	SaveInternalConfig:	Save settings (if true) to internal reboot memory after 
	//  each parameter change.
	Tango::DevBoolean	saveInternalConfig;

//	Attribute data members
public:
	Tango::DevDouble	*attr_Impedance_read;
	Tango::DevDouble	*attr_Amplitude_read;
	Tango::DevDouble	*attr_Offset_read;
	Tango::DevDouble	*attr_SampleRate_read;
	Tango::DevShort	*attr_TriggerMode_read;
	Tango::DevShort	*attr_Triggering_read;
	Tango::DevDouble	*attr_Delay_read;
	Tango::DevShort	*attr_TrackMode_read;
	Tango::DevShort	*attr_BurstMode_read;
	Tango::DevShort	*attr_BurstCycle_read;
	Tango::DevShort	*attr_BurstState_read;
	Tango::DevDouble	*attr_HighVoltage_read;
	Tango::DevDouble	*attr_LowVoltage_read;
	Tango::DevString	*attr_Configuration_File_read;
	Tango::DevShort	*attr_Function_read;
	Tango::DevDouble	*attr_Frequency_read;
	Tango::DevDouble	*attr_NoiseBandwidth_read;
	Tango::DevShort	*attr_OutputMode_read;
	Tango::DevShort	*attr_WaveformFilter_read;
	Tango::DevDouble	*attr_Waveform_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Agilent33500B(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Agilent33500B(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Agilent33500B(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Agilent33500B();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : Agilent33500B::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method     : Agilent33500B::write_attr_hardware()
	 *	Description: Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute Impedance related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Impedance(Tango::Attribute &attr);
	virtual void write_Impedance(Tango::WAttribute &attr);
	virtual bool is_Impedance_allowed(Tango::AttReqType type);
/**
 *	Attribute Amplitude related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Amplitude(Tango::Attribute &attr);
	virtual void write_Amplitude(Tango::WAttribute &attr);
	virtual bool is_Amplitude_allowed(Tango::AttReqType type);
/**
 *	Attribute Offset related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Offset(Tango::Attribute &attr);
	virtual void write_Offset(Tango::WAttribute &attr);
	virtual bool is_Offset_allowed(Tango::AttReqType type);
/**
 *	Attribute SampleRate related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_SampleRate(Tango::Attribute &attr);
	virtual void write_SampleRate(Tango::WAttribute &attr);
	virtual bool is_SampleRate_allowed(Tango::AttReqType type);
/**
 *	Attribute TriggerMode related methods
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_TriggerMode(Tango::Attribute &attr);
	virtual void write_TriggerMode(Tango::WAttribute &attr);
	virtual bool is_TriggerMode_allowed(Tango::AttReqType type);
/**
 *	Attribute Triggering related methods
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_Triggering(Tango::Attribute &attr);
	virtual void write_Triggering(Tango::WAttribute &attr);
	virtual bool is_Triggering_allowed(Tango::AttReqType type);
/**
 *	Attribute Delay related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Delay(Tango::Attribute &attr);
	virtual void write_Delay(Tango::WAttribute &attr);
	virtual bool is_Delay_allowed(Tango::AttReqType type);
/**
 *	Attribute TrackMode related methods
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_TrackMode(Tango::Attribute &attr);
	virtual void write_TrackMode(Tango::WAttribute &attr);
	virtual bool is_TrackMode_allowed(Tango::AttReqType type);
/**
 *	Attribute BurstMode related methods
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_BurstMode(Tango::Attribute &attr);
	virtual void write_BurstMode(Tango::WAttribute &attr);
	virtual bool is_BurstMode_allowed(Tango::AttReqType type);
/**
 *	Attribute BurstCycle related methods
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_BurstCycle(Tango::Attribute &attr);
	virtual void write_BurstCycle(Tango::WAttribute &attr);
	virtual bool is_BurstCycle_allowed(Tango::AttReqType type);
/**
 *	Attribute BurstState related methods
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_BurstState(Tango::Attribute &attr);
	virtual void write_BurstState(Tango::WAttribute &attr);
	virtual bool is_BurstState_allowed(Tango::AttReqType type);
/**
 *	Attribute HighVoltage related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_HighVoltage(Tango::Attribute &attr);
	virtual void write_HighVoltage(Tango::WAttribute &attr);
	virtual bool is_HighVoltage_allowed(Tango::AttReqType type);
/**
 *	Attribute LowVoltage related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_LowVoltage(Tango::Attribute &attr);
	virtual void write_LowVoltage(Tango::WAttribute &attr);
	virtual bool is_LowVoltage_allowed(Tango::AttReqType type);
/**
 *	Attribute Configuration_File related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Configuration_File(Tango::Attribute &attr);
	virtual bool is_Configuration_File_allowed(Tango::AttReqType type);
/**
 *	Attribute Function related methods
 *
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_Function(Tango::Attribute &attr);
	virtual void write_Function(Tango::WAttribute &attr);
	virtual bool is_Function_allowed(Tango::AttReqType type);
/**
 *	Attribute Frequency related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Frequency(Tango::Attribute &attr);
	virtual void write_Frequency(Tango::WAttribute &attr);
	virtual bool is_Frequency_allowed(Tango::AttReqType type);
/**
 *	Attribute NoiseBandwidth related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_NoiseBandwidth(Tango::Attribute &attr);
	virtual void write_NoiseBandwidth(Tango::WAttribute &attr);
	virtual bool is_NoiseBandwidth_allowed(Tango::AttReqType type);
/**
 *	Attribute OutputMode related methods
 *	Description: 0=> Normal
 *               1=> Gated (output activated by an external input)
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_OutputMode(Tango::Attribute &attr);
	virtual void write_OutputMode(Tango::WAttribute &attr);
	virtual bool is_OutputMode_allowed(Tango::AttReqType type);
/**
 *	Attribute WaveformFilter related methods
 *	Description: 0=>Normal
 *               1=>Step
 *               2=>OFF
 *
 *	Data type:	Tango::DevShort
 *	Attr type:	Scalar
 */
	virtual void read_WaveformFilter(Tango::Attribute &attr);
	virtual void write_WaveformFilter(Tango::WAttribute &attr);
	virtual bool is_WaveformFilter_allowed(Tango::AttReqType type);
/**
 *	Attribute Waveform related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 16000000
 */
	virtual void read_Waveform(Tango::Attribute &attr);
	virtual void write_Waveform(Tango::WAttribute &attr);
	virtual bool is_Waveform_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : Agilent33500B::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command State related method
	 *	Description: This command gets the device state (stored in its device_state data member) and returns it to the caller.
	 *
	 *	@returns Device state
	 */
	virtual Tango::DevState dev_state();
	/**
	 *	Command Reset related method
	 *	Description: Reset the generator
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);
	/**
	 *	Command On related method
	 *	Description: Switch ON the output
	 *
	 */
	virtual void on();
	virtual bool is_On_allowed(const CORBA::Any &any);
	/**
	 *	Command Off related method
	 *	Description: Switch off the output
	 *
	 */
	virtual void off();
	virtual bool is_Off_allowed(const CORBA::Any &any);
	/**
	 *	Command LoadConfigurationFile related method
	 *	Description: Loads a configuration file
	 *
	 *	@param argin Configuration file name (without the path)
	 */
	virtual void load_configuration_file(Tango::DevString argin);
	virtual bool is_LoadConfigurationFile_allowed(const CORBA::Any &any);
	/**
	 *	Command SaveConfigurationFile related method
	 *	Description: Save a configuration file
	 *
	 *	@param argin Configuration file name (without the path)
	 */
	virtual void save_configuration_file(Tango::DevString argin);
	virtual bool is_SaveConfigurationFile_allowed(const CORBA::Any &any);
	/**
	 *	Command GetConfigurationFilePath related method
	 *	Description: Returns the absolute confiration file path
	 *
	 *	@returns Configuration file path
	 */
	virtual Tango::DevString get_configuration_file_path();
	virtual bool is_GetConfigurationFilePath_allowed(const CORBA::Any &any);
	/**
	 *	Command SaveToFlash related method
	 *	Description: Save device configuration flash memory (block 0 used when booting)
	 *
	 */
	virtual void save_to_flash();
	virtual bool is_SaveToFlash_allowed(const CORBA::Any &any);
	/**
	 *	Command ReLoadConfigurationFile related method
	 *	Description: Reloads the currently loaded configuration file.
	 *               If no file has been previouly loaded, it does nothing.
	 *
	 */
	virtual void re_load_configuration_file();
	virtual bool is_ReLoadConfigurationFile_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : Agilent33500B::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Agilent33500B::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes

/*----- PROTECTED REGION END -----*/	//	Agilent33500B::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Agilent33500B::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions

/*----- PROTECTED REGION END -----*/	//	Agilent33500B::Additional Classes Definitions

}	//	End of namespace

#endif   //	Agilent33500B_H
